function game:mirror/init unless @e[type=armor_stand,name=mirrored_player]
scoreboard players tag @e[type=armor_stand,name=mirrored_player] remove mirror_kill


#Mirror Distance

execute @a[tag=isPlayer] ~ ~ ~ teleport @e[type=armor_stand,name=mirrored_player,tag=mirror_body] ~ ~-1.55 ~ ~ ~
execute @a[score_sneak_min=1,tag=isPlayer] ~ ~ ~ teleport @e[type=armor_stand,name=mirrored_player,tag=mirror_body] ~ ~-1.88 ~ ~ ~

execute @s ~ ~ ~ detect ~ ~ ~ minecraft:red_glazed_terracotta facing=east tp @e[type=armor_stand,name=mirrored_player,tag=mirror_body] ~1 ~ ~
execute @s ~ ~ ~ detect ~ ~ ~ minecraft:red_glazed_terracotta facing=east tp @s ~.5 ~ ~
execute @s ~ ~ ~ detect ~ ~ ~ minecraft:red_glazed_terracotta facing=west tp @e[type=armor_stand,name=mirrored_player,tag=mirror_body] ~-1 ~ ~
execute @s ~ ~ ~ detect ~ ~ ~ minecraft:red_glazed_terracotta facing=west tp @s ~-.5 ~ ~
execute @s ~ ~ ~ detect ~ ~ ~ minecraft:red_glazed_terracotta facing=south tp @e[type=armor_stand,name=mirrored_player,tag=mirror_body] ~ ~ ~1 
execute @s ~ ~ ~ detect ~ ~ ~ minecraft:red_glazed_terracotta facing=south tp @s ~ ~ ~.5
execute @s ~ ~ ~ detect ~ ~ ~ minecraft:red_glazed_terracotta facing=north tp @e[type=armor_stand,name=mirrored_player,tag=mirror_body] ~ ~ ~-1 
execute @s ~ ~ ~ detect ~ ~ ~ minecraft:red_glazed_terracotta facing=north tp @s ~ ~ ~-.5

execute @s ~ ~ ~ detect ~ ~ ~ minecraft:black_glazed_terracotta facing=east function game:mirror/distance/east
execute @s ~ ~ ~ detect ~ ~ ~ minecraft:black_glazed_terracotta facing=west function game:mirror/distance/west
execute @s ~ ~ ~ detect ~ ~ ~ minecraft:black_glazed_terracotta facing=south function game:mirror/distance/south
execute @s ~ ~ ~ detect ~ ~ ~ minecraft:black_glazed_terracotta facing=north function game:mirror/distance/north

execute @s ~ ~ ~ detect ~ ~ ~ minecraft:red_glazed_terracotta facing=east function game:mirror/distance/adjust_x
execute @s ~ ~ ~ detect ~ ~ ~ minecraft:red_glazed_terracotta facing=west function game:mirror/distance/adjust_x
execute @s ~ ~ ~ detect ~ ~ ~ minecraft:red_glazed_terracotta facing=south function game:mirror/distance/adjust_z
execute @s ~ ~ ~ detect ~ ~ ~ minecraft:red_glazed_terracotta facing=north function game:mirror/distance/adjust_z



#Mirror Rotation

execute @e[type=armor_stand,name=mirrored_player,tag=mirror_body] ~ ~ ~ function game:mirror/rotation/get

scoreboard players tag @e[type=armor_stand,name=mirrored_player,tag=mirror_align] remove mirror_align
execute @a[score_walk_min=5,tag=isPlayer] ~ ~ ~ scoreboard players tag @e[type=armor_stand,name=mirrored_player,tag=mirror_body] add mirror_align
execute @a[score_sprint_min=5,tag=isPlayer] ~ ~ ~ scoreboard players tag @e[type=armor_stand,name=mirrored_player,tag=mirror_body] add mirror_align
execute @e[type=armor_stand,name=mirrored_player,tag=mirror_align] ~ ~ ~ scoreboard players operation @s mirrorRotation = @e[type=armor_stand,name=mirrored_player,tag=mirror_head] mirrorRotation

scoreboard players operation @e[type=armor_stand,name=mirrored_player,tag=mirror_head] mirrorRotation -= @e[type=armor_stand,name=mirrored_player,tag=mirror_body] mirrorRotation
scoreboard players tag @e[type=armor_stand,name=mirrored_player,tag=mirror_fix] remove mirror_fix
scoreboard players remove @e[score_mirrorRotation_min=361] mirrorRotation 360
scoreboard players add @e[score_mirrorRotation=-1] mirrorRotation 360
scoreboard players add @e[type=armor_stand,name=mirrored_player,tag=mirror_head,score_mirrorRotation=-180] mirrorRotation 360
scoreboard players remove @e[type=armor_stand,name=mirrored_player,tag=mirror_head,score_mirrorRotation_min=180] mirrorRotation 360
scoreboard players tag @e[type=armor_stand,name=mirrored_player,tag=mirror_head,score_mirrorRotation=-40] add mirror_fix
scoreboard players add @e[type=armor_stand,name=mirrored_player,tag=mirror_head,score_mirrorRotation=-40] mirrorRotation 39
scoreboard players tag @e[type=armor_stand,name=mirrored_player,tag=mirror_head,score_mirrorRotation_min=40] add mirror_fix
scoreboard players remove @e[type=armor_stand,name=mirrored_player,tag=mirror_head,score_mirrorRotation_min=40] mirrorRotation 39
execute @e[type=armor_stand,name=mirrored_player,tag=mirror_fix] ~ ~ ~ scoreboard players operation @e[type=armor_stand,name=mirrored_player,tag=mirror_body] mirrorRotation += @s mirrorRotation
scoreboard players remove @e[type=armor_stand,name=mirrored_player,tag=mirror_fix,score_mirrorRotation=-1] mirrorRotation 39
scoreboard players add @e[type=armor_stand,name=mirrored_player,tag=mirror_fix,score_mirrorRotation_min=1] mirrorRotation 39

function game:mirror/rotation/apply
kill @e[type=area_effect_cloud,name=mirror_distance]



#Mirror Npc Animation
scoreboard players tag @e[type=armor_stand,name=mirrored_player,tag=mirror_head] add npc_animate
execute @e[type=armor_stand,name=mirrored_player,tag=mirror_align] ~ ~ ~ scoreboard players tag @e[type=armor_stand,name=mirrored_player,tag=mirror_head] remove npc_animate
execute @e[type=armor_stand,name=mirrored_player,tag=mirror_head] ~ ~ ~ scoreboard players set @s[tag=!npc_animate] npcStatic 0

scoreboard players tag @e[type=armor_stand,name=mirrored_player,tag=npc_sneaking_remove] remove npc_sneaking_remove
scoreboard players tag @e[type=armor_stand,name=mirrored_player,tag=npc_sneaking] add npc_sneaking_remove
execute @a[score_sneak_min=1] ~ ~ ~ scoreboard players tag @e[type=armor_stand,name=mirrored_player,tag=npc_sneaking_remove] remove npc_sneaking_remove
execute @e[type=armor_stand,name=mirrored_player,tag=mirror_legs] ~ ~ ~ entitydata @s[tag=npc_sneaking_remove] {Pose:{Head:[0f,0f,0f]},HandItems:[{id:"minecraft:dye",Count:1b,Damage:4s},{id:"minecraft:dye",Count:1b,Damage:5s}]}
execute @a[score_sneak_min=1,tag=isPlayer] ~ ~ ~ execute @e[type=armor_stand,name=mirrored_player,tag=mirror_legs] ~ ~ ~ entitydata @s[tag=!npc_sneaking] {Pose:{Head:[25f,0f,0f]},HandItems:[{id:"minecraft:dye",Count:1b,Damage:7s},{id:"minecraft:dye",Count:1b,Damage:8s}]}
scoreboard players tag @e[type=armor_stand,name=mirrored_player,tag=npc_sneaking] remove npc_sneaking
execute @a[score_sneak_min=1,tag=isPlayer] ~ ~ ~ scoreboard players tag @e[type=armor_stand,name=mirrored_player] add npc_sneaking




scoreboard players tag @e[type=armor_stand,name=mirrored_player,tag=mirror_head,score_npcMoving_min=0,score_npcMoving=0] remove npc_walking
scoreboard players tag @e[type=armor_stand,name=mirrored_player,tag=mirror_head,score_npcMoving_min=0,score_npcMoving=0] remove npc_sprinting
execute @a[score_walk_min=5,tag=isPlayer] ~ ~ ~ scoreboard players tag @e[type=armor_stand,name=mirrored_player,tag=mirror_head] add npc_walking
execute @a[score_sprint_min=5,tag=isPlayer] ~ ~ ~ scoreboard players tag @e[type=armor_stand,name=mirrored_player,tag=mirror_head] add npc_sprinting

execute @e[type=armor_stand,name=mirrored_player,tag=mirror_head] ~ ~ ~ execute @s[tag=npc_sprinting] ~ ~ ~ scoreboard players tag @s[tag=npc_walking] remove npc_walking
execute @e[type=armor_stand,name=mirrored_player,tag=mirror_head] ~ ~ ~ execute @s[tag=!npc_sprinting] ~ ~ ~ scoreboard players tag @s[tag=!npc_walking] remove npc_walking_reverse
execute @e[type=armor_stand,name=mirrored_player,tag=mirror_head] ~ ~ ~ execute @s[tag=!npc_sprinting] ~ ~ ~ scoreboard players tag @s[tag=!npc_walking] remove npc_sprinting_reverse
execute @e[type=armor_stand,name=mirrored_player,tag=mirror_head] ~ ~ ~ execute @s[tag=!npc_sprinting] ~ ~ ~ scoreboard players set @s[tag=!npc_walking] npcMoving 0